<?php
/*
Plugin Name: Custom Post Type - Speakers
Plugin URI: http://9seeds.com/plugins/
Description: Custom Post Type Plugin to create event speakers
Version: 1.0
Author: 9seeds.com
Author URI: http://9seeds.com/
*/

/* create the speaker post type */
function post_type_speakers() {
     $labels = array(
    'name' => _x('Speakers', 'post type general name'),
    'singular_name' => _x('Speakers', 'post type singular name'),
    'add_new' => _x('Add New', 'speakers'),
    'add_new_item' => __('Add New Speaker'),
    'edit_item' => __('Edit Speaker'),
    'edit' => _x('Edit', 'speakers'),
    'new_item' => __('New Speaker'),
    'view_item' => __('View Speaker'),
    'search_items' => __('Search Speakers'),
    'not_found' =>  __('No speakers found'),
    'not_found_in_trash' => __('No speakers found in Trash'),
    'view' =>  __('View Speaker'),
    'parent_item_colon' => ''
  );
  $args = array(
    'labels' => $labels,
    'public' => true,
    'publicly_queryable' => true,
    'show_ui' => true,
    'query_var' => true,
    'rewrite' => array("slug" => "speaker"),
    'capability_type' => 'post',
    'hierarchical' => false,
    'menu_position' => null,
    'supports' => array( 'title' )
  );

  register_post_type( 'speakers', $args);
}

add_action( 'init', 'post_type_speakers', 1 );

/* create custom meta boxes */

function custom_meta_boxes_speakers() {
    add_meta_box("speakers-details", "Speaker Details", "meta_cpt_speakers", "speakers", "normal", "low");
}

add_action('admin_menu', 'custom_meta_boxes_speakers');

function meta_cpt_speakers() {
    global $post;

	echo '<input type="hidden" name="speakers_noncename" id="speakers_noncename" value="' .
	wp_create_nonce( plugin_basename(__FILE__) ) . '" />';

   	echo '<label for="speaker_img">Speaker Photo URL</label><br />';

	//ajax upload
	$wud = wp_upload_dir();

?>

		<script type="text/javascript">
		jQuery(document).ready(function($) {
			var uploader = new qq.FileUploader({
				element: document.getElementById('speaker_upload'),
				action: '<?php echo get_bloginfo('siteurl'); ?>/',
				onComplete: function (id,fileName,responseJSON) {
					if(responseJSON.success == true)
						jQuery('#speaker_img').val('<?php echo $wud["url"]; ?>/'+fileName);
				}
			});           
		});	
		</script>
	<input style="width: 55%;" id="speaker_img" name="speaker_img" value="<?php echo get_post_meta($post->ID, 'speaker_img', true); ?>" type="text" /><div id="speaker_upload"></div>
	<?php

	echo '<label for="speaker_bio">Speaker Bio</label><br />';
	echo '<textarea style="width: 55%;" rows="10" cols="50" name="speaker_bio" />'.get_post_meta($post->ID, 'speaker_bio', true).'</textarea><br /><br />';

	echo '<label for="speaker_pres_title">Presentation Title</label><br />';
	echo '<input style="width: 55%;" type="text" name="speaker_pres_title" value="'.get_post_meta($post->ID, 'speaker_pres_title', true).'" /><br /><br />';

	echo '<label for="speaker_pres_description">Presentation Description</label><br />';
	echo '<textarea style="width: 55%;" rows="10" cols="50" name="speaker_pres_description" />'.get_post_meta($post->ID, 'speaker_pres_description', true).'</textarea><br /><br />';

	echo '<label for="speaker_url">Website (<strong>Use http://</strong>)</label><br />';
	echo '<input style="width: 55%;" type="text" name="speaker_url" value="'.get_post_meta($post->ID, 'speaker_url', true).'" /><br /><br />';

	echo '<label for="speaker_twitter_url">Twitter ID (<strong>No @ symbol, just the handle</strong>)</label><br />';
	echo '<input style="width: 55%;" type="text" name="speaker_twitter_url" value="'.get_post_meta($post->ID, 'speaker_twitter_url', true).'" /><br /><br />';

	echo '<label for="speaker_pres_url">Presentation URL (<strong>Use http://</strong>)</label><br />';
	echo '<input style="width: 55%;" type="text" name="speaker_pres_url" value="'.get_post_meta($post->ID, 'speaker_pres_url', true).'" /><br /><br />';
}

/* deal with uploading image */
if(isset ($_GET["qqfile"]) && strlen($_GET["qqfile"]))
{
	$pluginurl = WP_PLUGIN_URL . '/' . plugin_basename(dirname(__FILE__));
	include(WP_PLUGIN_DIR . '/' . plugin_basename(dirname(__FILE__)) . '/' . 'includes/upload.php');
	$wud = wp_upload_dir();

	/* list of valid extensions */
	$allowedExtensions = array('jpg', 'jpeg', 'gif', 'png', 'ico');

	/* max file size in bytes */
	$sizeLimit = 6 * 1024 * 1024;

	$uploader = new qqFileUploader($allowedExtensions, $sizeLimit);
	$result = $uploader->handleUpload($wud['path'].'/',true);
	
	echo htmlspecialchars(json_encode($result), ENT_NOQUOTES);
	exit;
}


function cpt_speakers_admin_scripts() {
	
	$pluginurl = WP_PLUGIN_URL . '/' . plugin_basename(dirname(__FILE__));

	wp_enqueue_script('fileuploader', $pluginurl.'/includes/fileuploader.js',array('jquery'));
	wp_enqueue_style('fileuploadercss',$pluginurl.'/css/fileuploader.css');
}

function cpt_speakers_admin_styles() {
	$pluginurl = WP_PLUGIN_URL . '/' . plugin_basename(dirname(__FILE__));
	
	wp_enqueue_style('thickbox');
	wp_enqueue_style('fileuploadercss', $pluginurl.'/css/fileuploader.css');
}

add_action('admin_print_scripts', 'cpt_speakers_admin_scripts');
add_action('admin_print_styles', 'cpt_speakers_admin_styles');

/* When the post is saved, saves our speaker data */
function save_speaker_postdata($post_id, $post) {
   	if ( !wp_verify_nonce( $_POST['speakers_noncename'], plugin_basename(__FILE__) )) {
	return $post->ID;
	}

	/* confirm user is allowed to save page/post */
	if ( 'page' == $_POST['post_type'] ) {
		if ( !current_user_can( 'edit_page', $post->ID ))
		return $post->ID;
	} else {
		if ( !current_user_can( 'edit_post', $post->ID ))
		return $post->ID;
	}

	/* ready our data for storage */
	foreach ($_POST as $key => $value) {
        $mydata[$key] = $value;
    }

	/* Add values of $mydata as custom fields */
	foreach ($mydata as $key => $value) {
		if( $post->post_type == 'revision' ) return;
		$value = implode(',', (array)$value);
		if(get_post_meta($post->ID, $key, FALSE)) {
			update_post_meta($post->ID, $key, $value);
		} else {
			add_post_meta($post->ID, $key, $value);
		}
		if(!$value) delete_post_meta($post->ID, $key);
	}
}

add_action('save_post', 'save_speaker_postdata', 1, 2); // save the custom fields

/* move template files on activation */
register_activation_hook(__FILE__, "speaker_activation");

function speaker_activation()
{
	//move files around
	$pluginpath = WP_PLUGIN_DIR.'/'.plugin_basename(dirname(__FILE__)).'/';
	$tmp = wp_upload_dir();
	$uploadpath = $tmp["basedir"].'/';
	$themepath =  get_template_directory()."/";

	$templates = glob($pluginpath."template*");
	foreach($templates as $t)
	{
		copy($t,$themepath.basename($t));
	}

	$singles = glob($pluginpath."single-speakers.php");
	foreach($singles as $s)
	{
		copy($s,$themepath.basename($s));
	}
}


?>